import iSATLibrary.ISatSolver;


public class Waerden {
	 
	 public void encode(ISatSolver solver, int j, int k, int n){
		  int[] pos = new int[j],	neg = new int[k];
		  for(int d=1; n-(j-1)*d>=1; d++){
				for(int i=1; i+(j-1)*d<=n; i++){
					 for(int a=0; a<=j-1; a++)
						  pos[a] = i+a*d;
					 solver.add_clause(pos);
				}
		  }
		  for(int d=1; n-(k-1)*d>=1; d++){
				for(int i=1; i+(k-1)*d<=n; i++){
					 for(int a=0; a<=k-1; a++)
						  neg[a] = -i-a*d;
					 solver.add_clause(neg); 
				}
		  }
	 }

	 public boolean solve(ISatSolver solver){
		  return solver.solve();
	 }

	 public void decode(ISatSolver solver){
		  System.out.println("SATISFIABLE");
		  int[] model = solver.get_int_model();
		  for(int i : model)
				System.out.print(i>0 ? 1+" " : 0+" ");
		  System.out.println();
	 }


	 public static void main(String[] args){
		  Waerden w = new Waerden();
		  ISatSolver solver = new ISatSolver("glueminisat");
		  if(args.length != 3){
				System.out.println("Usage : Waerden j k n");
				System.exit(1);
		  }
		  solver.set_verbosity(0);
		  int j = Integer.parseInt(args[0]);
		  int k = Integer.parseInt(args[1]);
		  int n = Integer.parseInt(args[2]);
		  w.encode(solver,j,k,n);
		  if (w.solve(solver)) w.decode(solver); else System.out.println("UNSATISFIABLE");		  
	 }
	 
}
